﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Markup;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace RestoredTilesToSpanMultipleRowsAndColumns
{
	public partial class MainWindow : Window
	{
        public MainWindow()
		{
			InitializeComponent();		
		}

		private void Form_Loaded(object sender, RoutedEventArgs e)
		{
            this.Form.Style = CreateTileViewStyle(3, 4);
        }

		private void RadButton_Click(object sender, RoutedEventArgs e)
        {
            int rows = int.Parse(this.rowsTb.Text);
            int columns = int.Parse(this.columnsTb.Text);
            this.Form.Style = CreateTileViewStyle(rows, columns);
        }    
        
        private static Style CreateTileViewStyle(int rowsCount, int columnsCount)
        {
            Style style = new Style(typeof(RadTileView));
            ItemsPanelTemplate panel = CreatePanel(rowsCount, columnsCount);
            style.Setters.Add(new Setter(RadTileView.ItemsPanelProperty, panel));
            return style;
        }

        private static ItemsPanelTemplate CreatePanel(int rowsCount, int columnsCount)
        {
            string panelString = @"<ItemsPanelTemplate  xmlns=""http://schemas.microsoft.com/winfx/2006/xaml/presentation"" xmlns:local=""clr-namespace:RestoredTilesToSpanMultipleRowsAndColumns;assembly=RestoredTilesToSpanMultipleRowsAndColumns"">" +
                                        @"<local:MultipleRowsAndColumnsPanel RowsCount=""" + rowsCount + @""" ColumnsCount=""" + columnsCount + @""" />" +
                                  "</ItemsPanelTemplate>";
            ItemsPanelTemplate panel =  (ItemsPanelTemplate)XamlReader.Parse(panelString);
            return panel;
        }
    }
}
